// Gnration d'un document PCo2006

function genDoc(numeroter) {
  genererHxDiv();
  numeroterHx(document, 1, '');
  genererEnTete();
}

function numeroterHx(elt, iHx, nx) {
  if (iHx<=6) {
    var i;
    var hxs=elt.getElementsByTagName("H"+iHx);
    for (i=0; i<hxs.length; i++) {
      var n=i+1;
      n=nx+n+".";
      hxs[i].innerHTML = n+" "+hxs[i].innerHTML;
      hxs[i].id=n; // ajout 11/3/06
      div=hxs[i].nextSibling;
      numeroterHx(div, iHx+1, n);
    }
  }
}


// Dveloppement/Rduction des balises Hx PCo2006

// dtermine l'attribut Class pour IE ou FireFox
var attClass=(document.all ? "className" : "Class"); 

// dveloppe ou rduit le bloc DIV
function dev_red(unElt) {
  var div=unElt.nextSibling;
  if (div.getAttribute(attClass)=="masque") {
    unElt.style.backgroundImage="url("+pathCss+"moins.gif)";
    div.setAttribute(attClass,"affiche");
  } 
  else {
    unElt.style.backgroundImage="url("+pathCss+"plus.gif)";
    div.setAttribute(attClass,"masque"); 		
  } 
}
 
// retourne Vrai si l'lment est un Hx      
function isTagHx(unElt,unNum) {
  if (unElt==null) return true;
  var i=unNum;
  while ( (i>0) && (unElt.tagName!=("H"+i)) ) i--;
  return i>0;  
}
        
function genererHxDiv() {
  extractCss();
  var i;
  for (i=4; i>0; i--) blocDiv(i);
}
		
function blocDiv(unHNum) {
  var div;
  var bal;
  var frag;
  var i;
  var hxs=document.getElementsByTagName("H"+unHNum);

  for (i=0; i<hxs.length; i++) {
    // ajoute l'vnement onClick sur les balises Hx [!] IE<>FireFox 
    if (document.all) hxs[i].onclick=function() { dev_red(this); };
    else hxs[i].setAttribute("onclick","dev_red(this);");

    bal=hxs[i].nextSibling; 
    frag=document.createDocumentFragment();
    while (! isTagHx(bal,unHNum)) {
	frag.appendChild(bal);
	bal=hxs[i].nextSibling;
    }
    div=document.createElement("div");
    div.appendChild(frag);
    div.setAttribute(attClass,"masque");
    document.body.insertBefore(div, bal);
  }	
}

// Gnration En-tte PCo2006

var pathCss;
var fileCss;

function extractCss() {
  var cssLinks=document.getElementsByTagName("link");
  var cssHref= new String(cssLinks[0].getAttribute("href"));
  var i= cssHref.lastIndexOf("/");
  pathCss=cssHref.substring(0,i);
  if (pathCss!="") pathCss+="/"; 
  fileCss=cssHref.substring(i+1,cssHref.length);
}

function changeCSS() {
  var cssLinks=document.getElementsByTagName("link");
  fileCss=(fileCss=="cours.css" ? "retro.css" : "cours.css");
  cssLinks[0].setAttribute("href", pathCss+fileCss);
}

function getMeta(unNom) {
  var metas=document.getElementsByTagName("meta");
  var i=0;
  while (i<metas.length) {
    if (metas[i].getAttribute("name")==unNom)
	  return metas[i].getAttribute("content");
	i++;
  }
}
    
function genererEnTete() {
  // le titre
  var titre=document.createElement("p");
  var data=document.createTextNode(document.title);
  titre.className="titre";
  titre.appendChild(data);

  // le sommaire inclus dans le titre
  var br=document.createElement("br");
  titre.appendChild(br);
  var sommaire=document.createElement("select");
  sommaire.id="sommaire";
  if (document.all) sommaire.onchange=function() { dev(); };
  else titre.setAttribute("onchange","dev();");
  titre.appendChild(sommaire);

  // insertion du titre
  var elt1=document.body.firstChild;
  document.body.insertBefore(titre,elt1);


  // evnements grs par l'lment 'titre'
  if (document.all) {
    titre.onmouseover=function() { afficherMenuSom(); };
    titre.onmouseout=function() { masquerMenuSom(); };
    //titre.onclick=function() { document.getElementById('sommaire').focus; };
  }
  else {
    titre.setAttribute("onmouseover","afficherMenuSom();");
    titre.setAttribute("onmouseout","masquerMenuSom();");
  }


  // le contenu + l'auteur (cf. balises META)
  var ref=document.createElement("p");
  var refText=document.createTextNode(getMeta("description")+" "+getMeta("author"));
  ref.className="ref";
  ref.appendChild(refText);
  document.body.insertBefore(ref,elt1);

  titre.appendChild(createMenu());
  setSommaire();
}

function setSommaire() {
	var som=document.getElementById("sommaire");
	var i;
	var divs=document.getElementsByTagName("DIV");
	for (i=0; i<divs.length; i++) {
		var hx=divs[i].previousSibling;
		var oOption = document.createElement("OPTION");
		//var titre=new String(hx.innerText);
		//alert(hx.innerHTML);
		var titre=hx.innerHTML;
		var id=titre.substring(0, titre.indexOf(" ", 0));
		oOption.text=titre;
		oOption.value=id;
		som.options.add(oOption);
	}
	som.size=divs.length;
}


function devTout() {
	var i;
	var divs=document.getElementsByTagName("DIV");
	for (i=0; i<divs.length; i++) {
		divs[i].setAttribute(attClass,"affiche");
		var hx=divs[i].previousSibling;
    	hx.style.backgroundImage="url("+pathCss+"moins.gif)";
	}
}

function redTout() {
	var i;
	var divs=document.getElementsByTagName("DIV");
	for (i=0; i<divs.length; i++) {
		divs[i].setAttribute(attClass,"masque");
		var hx=divs[i].previousSibling;
    	hx.style.backgroundImage="url("+pathCss+"plus.gif)";
	}
}

// dveloppe une entre du sommaire slectionne
function dev() {
	redTout();
	var som=document.getElementById("sommaire");
	var id=som.options[som.selectedIndex].value;
	deb=0;
    pos=id.indexOf(".", 0);
   	while (pos!=-1) {
   		var hx=document.getElementById(id.substring(0, pos+1));
    	hx.style.backgroundImage="url("+pathCss+"moins.gif)";
		var div=hx.nextSibling;
		div.setAttribute(attClass,"affiche");

   		deb=pos+1;
   	   	pos=id.indexOf(".", deb);
	}
	som.style.display="none";
}

function createMenu() {
  var menu=document.createElement("span");
  menu.id="menu";
  menu.appendChild(createButton('javascript:devTout();', "+"));
  menu.appendChild(createButton('javascript:redTout();', "-"));
  menu.appendChild(createButton('javascript:changeCSS();', "CSS"));
  return menu;
  //document.body.insertBefore(menu, document.body.firstChild);
}

function _createA(unHref, unTexte) {
  var a=document.createElement("a");
  a.href=unHref;
  a.innerText="["+unTexte+"]";
  return a;
}

function createButton(unHref, unTexte) {
  var b=document.createElement("button");
  //document.getElementById("menu").style.display="none";
  if (document.all) b.onclick=function() { eval(unHref); };
  else b.setAttribute("onclick",unHref);
  b.innerHTML=unTexte;
  return b;
}

function afficherMenuSom() {
  afficher("menu", "inline");
  afficher("sommaire", "block");

}

function masquerMenuSom() {
  afficher("menu", "none");
  afficher("sommaire", "none");

}

function afficher(unId, estVisible) {
  var id=document.getElementById(unId);
  id.style.display=estVisible;
}

