<?php // PCo2006
include("_gestionErreurs.inc.php");
include("bd/_connexion.inc.php");
include("bd/_donnees.inc.php");

if (! isset($_REQUEST['action'])) {
  $_REQUEST['action']='lister'; 
}

$action=$_REQUEST['action'];   

// Aiguillage selon l'étape
switch ($action) 
{
	case 'lister':
  	include("vRecapLister.php");
    break;
      
	case 'saisir':
		$nro=$_REQUEST['nro'];
		$nom=$_REQUEST['nom'];
		$cv=$_REQUEST['cv'];
		$totalKm=$_REQUEST['totalKm'];
  	include("vRecapSaisir.php");
    break;
      
	case 'creer':
		$nro=$_REQUEST['nro'];
		$nom=$_REQUEST['nom'];
		$cv=$_REQUEST['cv'];
		$totalKm=$_REQUEST['totalKm'];
		verifierDonnees($nro, $nom, $cv,$totalKm);       
		if (nbErreurs()==0) {        
			creerRecap($nro, $nom, $cv,$totalKm);
			include("vRecapLister.php");
		}
    else {
			include("vRecapSaisir.php");
    }
    break;
	
	case 'supprimer':
		$nro=$_REQUEST['nro'];
		supprimerRecap($nro);
		include("vRecapLister.php");
    break;            
}

// Fermeture de la connexion au serveur MySql
mysql_close();

function verifierDonnees($unNro, $unNom, $unCv, $unTotalKm) {
	if ($unNro=="" || $unNom=="" || $unCv=="" || $unTotalKm=="") {
		ajouterErreur('Chaque champ suivi du caractère * est obligatoire');
	}
	if ($unNro!="")
	{
      if (!estEntier($unNro)) ajouterErreur("Le numro doit tre un entier");
      else if (estUnNroRecap($unNro)) ajouterErreur("Le numro $unNro existe déjà");
	}
	if ($unCv!="") {
		if (!estEntier($unCv)) ajouterErreur("Le nombre de chevaux n'est pas un entier !");
	}
	if ($unTotalKm!="") {
		if (!estEntier($unTotalKm)) ajouterErreur("Le total des kilomtres n'est pas un entier !");
	}
}

function estEntier($valeur) {
	return !ereg("[^0-9]",$valeur);
}

?> 
